%global momorel 3
%global md5sum_src0 8012acea71b35c18247bd92c4721589d

#define preview -preview

Summary: Qt toolkit
Name:	 qt4
Version: 4.3.0
Release: %{momorel}m%{?dist}

License: GPL
Group: 	 System Environment/Libraries
Url:   	 http://www.trolltech.com/products/qt/
%NoSource 0 ftp://ftp.trolltech.com/qt/source/qt-x11-opensource-src-%{version}.tar.gz %{md5sum_src0}
BuildRoot: %{_tmppath}/%{name}-%{version}-root

Source1: Trolltech.conf

# See http://bugzilla.redhat.com/223663
ExclusiveArch: %{ix86} x86_64 ppc ppc64 sparc sparc64
Source5: qconfig-multilib.h

# search for assistant-qt4 instead of (qt3's) assistant in $PATH 
Patch1: qt-x11-opensource-src-4.3.0-qassistant-qt4.patch
# multilib hacks 
Patch2: qt-x11-opensource-src-4.2.2-multilib.patch
# qt-copy patches

Source10: qt4-wrapper.sh
Source11: qt4.sh
Source12: qt4.csh
# /etc/rpm/macros.qt4
Source13: qt4.macros

Source20: assistant.desktop
Source21: designer.desktop
Source22: linguist.desktop
Source23: qtdemo.desktop
Source24: qtconfig.desktop

## optional plugin bits
# set to -no-sql-<driver> to disable
# set to -qt-sql-<driver> to enable *in* qt library
%define mysql  -plugin-sql-mysql
%define odbc   -plugin-sql-odbc 
%define psql   -plugin-sql-psql 
%define sqlite -plugin-sql-sqlite 

# undefine to disable these
%if 0
%define nas     -system-nas-sound
%endif
# KDE4 needs dbus support
%if 1
%define qdbus	-qdbus
BuildRequires: dbus-devel >= 0.62
%endif

%define qtdir %{_libdir}/qt4
# See http://bugzilla.redhat.com/196901
# these should match contents of SOURCE13: 
%define _qt4_prefix 	%{_libdir}/qt4
%define _qt4_bindir	%{_qt4_prefix}/bin
%define _qt4_datadir 	%{_datadir}/qt4
%define _qt4_docdir	%{_docdir}/qt4
%define _qt4_headerdir 	%{_includedir} 
%define _qt4_libdir	%{_libdir}
%define _qt4_plugindir	%{_qt4_prefix}/plugins
%define _qt4_sysconfdir	%{_sysconfdir}
%define _qt4_translationdir %{_qt4_datadir}/translations

%if "%{_qt4_libdir}" != "%{_libdir}"
# needed for runtime, as well as pre,post
Prereq:  /etc/ld.so.conf.d
%endif

BuildRequires: cups-devel
BuildRequires: desktop-file-utils
BuildRequires: findutils
BuildRequires: fontconfig-devel
BuildRequires: freetype-devel
BuildRequires: libjpeg-devel
BuildRequires: libmng-devel
BuildRequires: libpng-devel
BuildRequires: libtiff-devel
BuildRequires: libungif-devel
BuildRequires: freetype-devel
BuildRequires: zlib-devel
BuildRequires: glib2-devel
BuildRequires: openssl-devel

## In theory, should be as simple as:
#define x_deps libGL-devel libGLU-devel
## but, "xorg-x11-devel: missing dep on libGL/libGLU" - http://bugzilla.redhat.com/211898 
%define x_deps xorg-x11-devel xorg-x11-Mesa-libGL xorg-x11-Mesa-libGLU
%if 1
%define x_deps libICE-devel libSM-devel libXcursor-devel libXext-devel libXfixes-devel libXft-devel libXi-devel libXinerama-devel libXrandr-devel libXrender-devel libXt-devel libX11-devel xorg-x11-proto-devel libGL-devel libGLU-devel
%endif
BuildRequires: %{x_deps}

%if "%{?nas}" == "-system-nas-sound"
BuildRequires: nas-devel
%endif

%if "%{?mysql}" != "-no-sql-mysql"
BuildRequires: mysql-devel >= 4.0
%endif

%if "%{?psql}" != "-no-sql-psql"
BuildRequires: postgresql-devel >= 8.2.3
%endif

%if "%{?odbc}" != "-no-sql-odbc"
BuildRequires: unixODBC-devel
%endif

%if "%{?sqlite:1}" != "-no-sql-sqlite"
%define _system_sqlite -system-sqlite
BuildRequires: sqlite-devel
%endif

%description 
Qt is a software toolkit for developing applications.

This package contains base tools, like string, xml, and network
handling.

%package devel
Summary: Development files for the Qt toolkit
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: %{name}-x11 = %{version}-%{release}
Requires: %{x_deps}
Requires: libpng-devel
Requires: libjpeg-devel
Requires: pkgconfig
#Requires: glib2-devel
## %%{_sysconfdir}/rpm/macros.qt4
Requires: rpm

%description devel
This package contains the files necessary to develop
applications using the Qt toolkit.  Includes:
Qt Linguist

%package doc
Summary: API documentation, demos and example programs for %{name}
Group: Documentation
Requires: %{name} = %{version}-%{release}
Provides: %{name}-assistant = %{version}-%{release}

%description doc
%{summary}.  Includes:
Qt Assistant, Qt Demo

%package odbc 
Summary: ODBC driver for Qt's SQL classes
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}

%description odbc 
%{summary}.

%package mysql 
Summary: MySQL driver for Qt's SQL classes
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}

%description mysql 
%{summary}.

%package postgresql 
Summary: PostgreSQL driver for Qt's SQL classes
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}

%description postgresql 
%{summary}.

%package sqlite 
Summary: SQLite driver for Qt's SQL classes
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}

%description sqlite 
%{summary}.

%package x11
Summary: Qt GUI-related libraries
Group: System Environment/Libraries
Requires: %{name} = %{version}-%{release}

%description x11
Qt libraries which are used for drawing widgets and OpenGL items.

%prep
%setup -q -n qt-x11-opensource-src-%{version}

%patch1 -p1 -b .assistant4
# don't use -b on mkspec files, else they get installed too.
%patch2 -p1

# drop -fexceptions from $RPM_OPT_FLAGS
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS | sed 's|-fexceptions||g'`

## customize our platform
%if "%{_lib}" == "lib64"
%define platform linux-g++-64
%else
%define platform linux-g++
%endif
sed -i \
  -e "s|-O2|$RPM_OPT_FLAGS|g" \
  -e "s|g++.conf|g++-multilib.conf|g" mkspecs/%{platform}/qmake.conf
sed -e "s|^QMAKE_CFLAGS_RELEASE|#QMAKE_CFLAGS_RELEASE|g" \
 mkspecs/common/g++.conf > mkspecs/common/g++-multilib.conf
  
## FIXME, http://bugzilla.redhat.com/230224
# On the surface, looks like a good idea to strip -I/usr/include, -L/usr/lib, 
# but it turns out qmake-consuming apps expect/use QMAKE_INCDIR_QT directly 
# (e.g. PyQt4, texmaker), and don't cope with null values
#if "%{_qt4_headerdir}" == "%{_includedir}"
#sed -i -e "s|^QMAKE_INCDIR_QT.*=.*|QMAKE_INCDIR_QT       =|" mkspecs/common/linux.conf
#endif
%if "%{_qt4_libdir}" == "%{_libdir}"
sed -i -e "s|^QMAKE_LIBDIR_QT.*=.*|QMAKE_LIBDIR_QT       =|" mkspecs/common/linux.conf
%endif

# undefine QMAKE_STRIP, so we get useful -debuginfo pkgs
sed -i -e "s|^QMAKE_STRIP.*=.*|QMAKE_STRIP             =|" mkspecs/common/linux.conf

# set correct lib path
if [ "%{_lib}" == "lib64" ] ; then
  sed -i -e "s,/usr/lib /lib,/usr/%{_lib} /%{_lib},g" config.tests/{unix,x11}/*.test
  sed -i -e "s,/lib /usr/lib,/%{_lib} /usr/%{_lib},g" config.tests/{unix,x11}/*.test
fi

%build

# build shared, threaded (default) libraries
echo yes | ./configure -v \
  -prefix %{_qt4_prefix} \
  -bindir %{_qt4_bindir} \
  -datadir %{_qt4_datadir} \
  -docdir %{_qt4_docdir} \
  -headerdir %{_qt4_headerdir} \
  -libdir %{_qt4_libdir} \
  -plugindir %{_qt4_plugindir} \
  -sysconfdir %{_qt4_sysconfdir} \
  -translationdir %{_qt4_translationdir} \
  -platform %{platform} \
  -release \
  -shared \
  -cups \
  -no-exceptions \
  -fontconfig \
  -largefile \
  -qt-gif \
  -no-rpath \
  -no-separate-debug-info \
  -sm \
  -stl \
  -system-libmng \
  -system-libpng \
  -system-libjpeg \
  -system-libtiff \
  -system-zlib \
  -tablet \
  -xcursor \
  -xfixes \
  -xinerama \
  -xshape \
  -xrandr \
  -xrender \
  -xkb \
  -glib \
  -openssl \
  %{?qdbus} %{!?qdbus:-no-qdbus} \
  %{?nas} %{!?nas:-no-nas-sound} \
  %{?mysql} \
  %{?psql} \
  %{?odbc} \
  %{?sqlite} %{?_system_sqlite}

%make

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

make install INSTALL_ROOT=%{buildroot}

# Add desktop file(s)
desktop-file-install \
  --dir %{buildroot}%{_datadir}/applications \
  --vendor="%{name}" \
  --remove-category Application \
  --remove-category AdvancedSettings \
  %{SOURCE20} %{SOURCE21} %{SOURCE22} %{SOURCE23} %{SOURCE24}

# Install icons
mkdir -p %{buildroot}%{_datadir}/pixmaps
install -m 644 tools/assistant/images/qt.png %{buildroot}%{_datadir}/pixmaps/qtconfig4.png
install -m 644 tools/assistant/images/designer.png %{buildroot}%{_datadir}/pixmaps/designer4.png
install -m 644 tools/assistant/images/assistant.png %{buildroot}%{_datadir}/pixmaps/assistant4.png
install -m 644 tools/assistant/images/linguist.png %{buildroot}%{_datadir}/pixmaps/linguist4.png
install -m 644 tools/assistant/images/qt.png %{buildroot}%{_datadir}/pixmaps/qtdemo4.png

## pkg-config
# strip extraneous dirs/libraries -- Rex
# safe ones
glib2_libs=$(pkg-config --libs glib-2.0 gthread-2.0)
for dep in -laudio -ldbus-1 -lfreetype -lfontconfig ${glib2_libs} -lmng -ljpeg -lpng -lm -lz \
  -L%{_builddir}/qt-x11%{?preview}-opensource-src-%{version}/lib ; do
  sed -i -e "s|$dep ||g" %{buildroot}%{_qt4_libdir}/lib*.la ||:
  sed -i -e "s|$dep ||g" %{buildroot}%{_qt4_libdir}/pkgconfig/*.pc
  sed -i -e "s|$dep ||g" %{buildroot}%{_qt4_libdir}/*.prl
done
# riskier
for dep in -lXrender -lXrandr -lXcursor -lXfixes -lXinerama -lXi -lXft -lXt -lXext -lX11 -lSM -lICE -ldl -lpthread ; do
  sed -i -e "s|$dep ||g" %{buildroot}%{_qt4_libdir}/lib*.la ||:
  sed -i -e "s|$dep ||g" %{buildroot}%{_qt4_libdir}/pkgconfig/*.pc
  sed -i -e "s|$dep ||g" %{buildroot}%{_qt4_libdir}/*.prl
done
# nuke dandling reference(s) to %%buildroot
sed -i -e "/^QMAKE_PRL_BUILD_DIR/d" %{buildroot}%{_qt4_libdir}/*.prl

# -doc make symbolic link to _qt4_docdir
rm -rf %{buildroot}%{_qt4_prefix}/doc
ln -s  ../../share/doc/qt %{buildroot}%{_qt4_prefix}/doc

# put LICENSE.* files in %%qt4_prefix, some apps' configure scripts expect to find them here
install -p -m644 LICENSE.* %{buildroot}%{_qt4_prefix}/

## Make symlinks in %%_bindir
%if "%{_bindir}" != "%{_qt4_bindir}"
mkdir -p %{buildroot}%{_bindir}
pushd %{buildroot}%{_qt4_bindir}
for i in *; do
  case "${i}" in
    assistant|designer|linguist|lrelease|lupdate|moc|qmake|qtconfig|qtdemo|uic|uic3)
      LINK="${i}-qt4"
      ln -s "${i}" "%{buildroot}%{_qt4_bindir}/${LINK}"
      ;;
    *)
      LINK="${i}"
      ;;
  esac
  install -p -m755 -D %{SOURCE10} %{buildroot}%{_bindir}/${LINK}
done
popd
%endif

# _debug lib symlinks (see bug #196513)
pushd %{buildroot}%{_qt4_libdir}
for lib in libQt*.so ; do
  ln -s $lib $(basename $lib .so)_debug.so
done
for lib in libQt*.a ; do
  ln -s $lib $(basename $lib .a)_debug.a
done
popd

# .la files, die, die, die.
rm -f %{buildroot}%{_qt4_libdir}/lib*.la

## multilib: qconfig
mv %{buildroot}%{_qt4_headerdir}/Qt/qconfig.h %{buildroot}%{_qt4_headerdir}/QtCore/qconfig-%{_arch}.h
install -p -m644 -D %{SOURCE5}              %{buildroot}%{_qt4_headerdir}/QtCore/qconfig-multilib.h
ln -sf qconfig-multilib.h                   %{buildroot}%{_qt4_headerdir}/QtCore/qconfig.h
ln -sf ../QtCore/qconfig.h                  %{buildroot}%{_qt4_headerdir}/Qt/qconfig.h
%ifarch i486 i586 i686
ln -sf qconfig-%{_arch}.h                   %{buildroot}%{_qt4_headerdir}/QtCore/qconfig-i386.h
%endif

## multilib: mkspecs
%if "%{qt4_datadir}" != "%{_qt4_prefix}"
# qt4.(sh|csh), QMAKESPEC
#install -p -m755 -D %{SOURCE11} %{buildroot}/etc/profile.d/%{name}-%{_arch}.sh
#install -p -m755 -D %{SOURCE12} %{buildroot}/etc/profile.d/%{name}-%{_arch}.csh
#sed -i -e "s|@@QMAKESPEC@@|%{platform}|" %{buildroot}/etc/profile.d/%{name}-%{_arch}.*
# mkspecs 
mkdir %{buildroot}%{_qt4_prefix}/mkspecs
mv  	%{buildroot}%{_qt4_datadir}/mkspecs/{default,linux-g++*,qconfig.pri} \
  	%{buildroot}%{_qt4_prefix}/mkspecs/
ln -s	%{_qt4_datadir}/mkspecs/common %{buildroot}%{_qt4_prefix}/mkspecs/common
%endif

%if "%{_qt4_libdir}" != "%{_libdir}"
mkdir -p %{buildroot}/etc/ld.so.conf.d
echo "%{_qt4_libdir}" > %{buildroot}/etc/ld.so.conf.d/%{name}-%{_arch}.conf
%endif

# rpm macros
install -p -m644 -D %{SOURCE13} %{buildroot}%{_sysconfdir}/rpm/macros.qt4

# Trolltech.conf
install -p -m644 -D %{SOURCE1} %{buildroot}%{_qt4_sysconfdir}/Trolltech.conf

%check
# verify %%_qt_* vs qmake -query equivalents
ERR=0
PATH=%{buildroot}%{_qt4_bindir}:$PATH
export PATH
set -x
test "%{_qt4_prefix}" == "$(qmake -query QT_INSTALL_PREFIX)" || ERR=1
test "%{_qt4_bindir}" == "$(qmake -query QT_INSTALL_BINS)" || ERR=1
test "%{_qt4_datadir}" == "$(qmake -query QT_INSTALL_DATA)" || ERR=1
test "%{_qt4_docdir}" == "$(qmake -query QT_INSTALL_DOCS)" || ERR=1
test "%{_qt4_headerdir}" == "$(qmake -query QT_INSTALL_HEADERS)" || ERR=1 
test "%{_qt4_libdir}" == "$(qmake -query QT_INSTALL_LIBS)" || ERR=1 
test "%{_qt4_plugindir}" == "$(qmake -query QT_INSTALL_PLUGINS)" || ERR=1
test "%{_qt4_sysconfdir}" == "$(qmake -query QT_INSTALL_CONFIGURATION)" || ERR=1
exit $ERR

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc README* 
%{_qt4_prefix}/LICENSE.*
%if "%{_qt4_libdir}" != "%{_libdir}"
/etc/ld.so.conf.d/*
%dir %{_qt4_libdir}
%endif
%dir %{_qt4_prefix}
%dir %{_qt4_bindir}
%dir %{_qt4_datadir}
%if "%{_qt4_sysconfdir}" != "%{_sysconfdir}"
%dir %{_qt4_sysconfdir}
%endif
%config(noreplace) %{_qt4_sysconfdir}/Trolltech.conf
%{_qt4_datadir}/phrasebooks/
%{_qt4_libdir}/libQtCore.so.*
%if "%{?qdbus}" == "-qdbus"
%{_qt4_libdir}/libQtDBus.so.*
%endif
%{_qt4_libdir}/libQtNetwork.so.*
%{_qt4_libdir}/libQtScript.so.*
%{_qt4_libdir}/libQtSql.so.*
%{_qt4_libdir}/libQtTest.so.*
%{_qt4_libdir}/libQtXml.so.*
%dir %{_qt4_plugindir}
%dir %{_qt4_plugindir}/sqldrivers/
%{_qt4_translationdir}/

%files x11 
%defattr(-,root,root,-)
%{_qt4_libdir}/libQt3Support.so.*
%{_qt4_libdir}/libQtAssistantClient.so.*
%{_qt4_libdir}/libQtDesigner.so.*
%{_qt4_libdir}/libQtDesignerComponents.so.*
%{_qt4_libdir}/libQtGui.so.*
%{_qt4_libdir}/libQtOpenGL.so.*
%{_qt4_libdir}/libQtSvg.so.*
%{_qt4_plugindir}/*
%exclude %{_qt4_plugindir}/designer
%exclude %{_qt4_plugindir}/sqldrivers
#-config bits
%{_qt4_bindir}/qt*config*
%{_bindir}/qt*config*
%{_datadir}/applications/*qtconfig*.desktop
%{_datadir}/pixmaps/qtconfig4.png

%files devel
%defattr(-,root,root,-)
#config /etc/profile.d/*
%{_sysconfdir}/rpm/macros.*
%{_qt4_bindir}/lrelease*
%{_qt4_bindir}/lupdate*
%{_qt4_bindir}/moc*
%if "%{?qdbus}" == "-qdbus"
%{_qt4_bindir}/qdbus*
%{_bindir}/qdbus*
%endif
%{_qt4_bindir}/pixeltool*
%{_qt4_bindir}/qmake*
%{_qt4_bindir}/qt3to4
%{_qt4_bindir}/rcc*
%{_qt4_bindir}/uic*
%{_bindir}/lrelease*
%{_bindir}/lupdate*
%{_bindir}/pixeltool*
%{_bindir}/moc*
%{_bindir}/qmake*
%{_bindir}/qt3to4
%{_bindir}/rcc*
%{_bindir}/uic*
%if "%{_qt4_headerdir}" != "%{_includedir}"
%dir %{_qt4_headerdir}/
%endif
%{_qt4_headerdir}/*
%{_qt4_datadir}/mkspecs/
%{_qt4_prefix}/mkspecs/
%{_qt4_datadir}/q3porting.xml
%{_qt4_libdir}/libQt*.so
# remaining static lib: libQtUiTools.a 
%{_qt4_libdir}/libQt*.a
%{_qt4_libdir}/libQt*.prl
%{_libdir}/pkgconfig/*.pc
# Qt designer
%{_bindir}/designer*
%{_qt4_bindir}/designer*
%{_qt4_plugindir}/designer/
%{_datadir}/pixmaps/designer4.png
%{_datadir}/applications/*designer*.desktop
# Qt Linguist
%{_qt4_bindir}/linguist*
%{_bindir}/linguist*
%{_datadir}/applications/*linguist*.desktop
%{_datadir}/pixmaps/linguist4.png

%files doc
%defattr(-,root,root,-)
%dir %{_qt4_docdir}/
%{_qt4_docdir}/html
%{_qt4_prefix}/doc
%{_qt4_prefix}/demos/
%{_qt4_prefix}/examples/
# Qt Assistant
%{_qt4_bindir}/assistant*
%{_bindir}/assistant*
%{_datadir}/applications/*assistant*.desktop
%{_datadir}/pixmaps/assistant4.png
# Qt Demo
%{_qt4_bindir}/qt*demo*
%{_bindir}/qt*demo*
%{_datadir}/applications/*qtdemo*.desktop
%{_datadir}/pixmaps/qtdemo4.png

%if "%{?odbc}" == "-plugin-sql-odbc"
%files odbc 
%defattr(-,root,root,-)
%{_qt4_plugindir}/sqldrivers/libqsqlodbc*
%endif

%if "%{?psql}" == "-plugin-sql-psql"
%files postgresql 
%defattr(-,root,root,-)
%{_qt4_plugindir}/sqldrivers/libqsqlpsql*
%endif

%if "%{?mysql}" == "-plugin-sql-mysql"
%files mysql 
%defattr(-,root,root,-)
%{_qt4_plugindir}/sqldrivers/libqsqlmysql*
%endif

%if "%{?sqlite}" == "-plugin-sql-sqlite"
%files sqlite 
%defattr(-,root,root,-)
%{_qt4_plugindir}/sqldrivers/libqsqlite*
%endif

%changelog
* Sat Jul 14 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.3.0-3m)
- merge Fedora's changes
- make _qt4_* macro usage consistent (with %%check's)
- fix %%_qt4_prefix/doc symlink
- remove Application from "Categories" of desktop files

* Fri Jun 29 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.3.0-2m)
- fix qt4.macros

* Wed Jun  6 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.3.0-1m)
- Qt 4.3.0
- update qassistant.patch (from Fedora)
- build with libtiff and openssl support

* Tue May 15 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.2.3-4m)
- import qt-x11-opensource-src-4.2.3-qt#153635.patch
  http://www.trolltech.com/developer/task-tracker/?method=entry&id=153635

* Sun Apr 15 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.2.3-3m)
- revise %%install for i386

* Sun Apr 15 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.2.3-2m)
- install qconfig-i386.h

* Sun Apr  8 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.2.3-1m)
- Qt 4.2.3
- sync with Fedora
- clean up spec file

* Sat Mar 31 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.2.2-4m)
- BuildRequires: freetype2-devel -> freetype-devel

* Sun Mar 11 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.2.2-3m)
- rebuild against postgresql-8.2.3

* Wed Feb 28 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.2.2-2m)
- add md5sum_src0

* Sun Feb 25 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (4.2.2-1m)
- Qt 4.2.2
- enable dbus support for KDE4
- install icons
- update desktop files for icons

* Mon Oct 30 2006 Masayuki SANO <nosanosa@momonga-linux.org>
- (4.2.1-1m)
- first import to Momonga from Fedora Extra
- - based on qt4-4.2.0-1.src.rpm (see http://cvs.fedora.redhat.com/viewcvs/devel/qt4/?root=extras)
- This package can coexist with Qt3.
- This package should not affect any other packages of Qt3 applications. (...I hope.)
- Whether KDE4 can be builded with this Qt4 package or not is NOT tested at all.

* Wed Oct 04 2006 Rex Dieter 4.2.0-1
- 4.2.0(final)

* Thu Sep 28 2006 Kevin Kofler <Kevin@tigcc.ticalc.org> 4.2.0-0.9.20060927
- update to 4.2.0-snapshot-20060927
- update QDBus executable names
- -x11: exclude plugins/designer (which belong to -devel)
- BuildConflicts: qt4-devel
- drop -fno-strict-aliasing hack (fc5+)

* Wed Sep 27 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.2.0-0.8.rc1
- qtconfig.desktop: Categories=+AdvancedSettings;Settings

* Fri Sep 08 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.2.0-0.7.rc1
- 4.2.0-rc1

* Fri Aug 28 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.2.0-0.6.20060821
- update to 4.2.0-snapshot-20060821 (same as today's qt-copy)
- -no-separate-debug-info
- - ./configure -xfixes, BR: libXfixes-devel

* Mon Aug 07 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.2.0-0.5.tp1
- fix empty -debuginfo
- use $RPM_OPT_FLAGS

* Thu Jul 20 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.2.0-0.4.tp1
- strip -laudio, -ldbus-1, -lglib-2.0 from .pc files

* Thu Jul 20 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.2.0-0.3.tp1
- -no-reduce-exports (for now)
- -fno-strict-aliasing (fc5+)

* Fri Jul 07 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.2.0-0.2.tp1
- -system-nas-sound, BR: nas-devel (bug # 197937)
- -qdbus (fc6+, BR: dbus-devel >= 0.62)
- -glib (BR: glib2-devel)

* Fri Jun 30 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.2.0-0.1.tp1
- 4.2.0-tp1 (technology preview 1)

* Thu Jun 29 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.4-5
- make FHS-friendly (bug #196901)
- cleanup %%_bindir symlinks, (consistently) use qt4 postfix

* Wed Jun 28 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.4-4
- x11: split-out gui(x11) from non-gui bits (bug #196899)

* Mon Jun 26 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.4-3
- -debug: drop, adds nothing over -debuginfo, make lib..._debug 
  symlinks instead (bug #196513)
- assistant.desktop: fix tooltip (bug #197039)

* Mon Jun 26 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.4-2
- -devel: include -debug libs (bug #196513)
- -devel: move libQtDesigner here
- -config: mash into main pkg, should be multilib friendly now

* Fri Jun 23 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.4-1
- 4.1.4

* Tue Jun 20 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.3-9
- make each sql plugin optional

* Fri Jun 09 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.3-8
- qmake.conf: undefine QMAKE_STRIP to get useful -debuginfo (bug #193602)
- move (not symlink) .pc files into %%_libdir/pkgconfig

* Thu Jun 08 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.3-7
- *really* fix qt4-wrapper.sh for good this time.

* Mon May 29 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.3-6
- make qt4-wrapper.sh use rpm when pkg-config/qt4-devel isn't
  installed (#193369)

* Fri May 26 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.3-5
- strip -lXi from .pc files (#193258)
- simplify sql plugin builds via %%buildSQL macro
- -libdir %%qt_libdir 

* Wed May 24 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.3-4
- move (most) %%dir ownership (back) to main pkg

* Sun May 21 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.3-3
- fix %%mysql_libs macro

* Sat May 20 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.3-2
- -mysql: use mysql_config for setting cflags/ldflags.
- -mysql: BR: mysql-devel > 4.0

* Sat May 20 2006 Laurent Rineau <laurent.rineau__fc_extra@normalesup.org>
- Fix the last reference to %{qtdir}/lib: use %{_lib} instead of "lib".
- Fix the ownership of subpackages: they need to own parents of directories they install files in.

* Fri May 19 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.3-1
- 4.1.3
- %%qtdir/lib/*.pc -> %%qtdir/%%_lib/*.pc 
  (hopefully, the last hardcoded reference to %%qtdir/lib)

* Fri May 19 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.2-20
- fix some unowned dirs
- try harder to purge %%builddir from .pc,.prl files
- -docdir %%_docdir/%%name-doc-%%version, since we use %%doc macro in main pkg
- -doc: own %%qt_docdir
- use qt4-wrapper.sh to ensure launch of qt4 versions of apps that
  (may) overlap with those from qt3 
- use %%qtdir/%%_lib in ld.so.conf.d/*.conf files too

* Tue May 16 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.2-19
- drop libQtAssistantClient,libQtUiTools shlib patches

* Tue May 16 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.2-18
- %%_bindir symlinks: qtconfig4 -> qt4config, qtdemo4 -> qt4demo
- -libdir %%qtdir/%%_lib, simplifies %%_lib != lib case
- -docdir %%_docdir/%%name-%%version
- build shared versions of libQtAssistantClient,libQtUiTools too
- strip extraneous -L paths, libs from *.prl files too

* Tue May 16 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.2-17
- .desktop: Qt -> Qt4, and Comment= (where missing)
- -devel: include -designer here, Obsoletes/Provides: %%name-designer.
   It's small, simplifies things... one less subpkg to worry about.
- -doc: include %%qtdir/doc symlink here
- -docdir %%_docdir/%%name-doc-%%version

* Mon May 15 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.2-16
- set/use RPM_OPT_FLAGS only for our platform
- (really) don't give %%_bindir symlink for qt3to4 another "4" suffix
- don't add 4 suffix to uic3, rcc (they don't conflict with qt(3)-devel)
- -devel: add  linguist.desktop
- -doc: move assistant here, Provides: %%{name}-assistant, add assistant.desktop
- -doc: add qtdemo.desktop
- -doc: Requires qt4 (instead of qt4-devel)
- assistant4.patch: search for assistant4 instead of (qt3's) assistant in $PATH 
- -qtconfig: add qtconfig.desktop
- updated %%sumaries to mention where (some) tools are, including assistant, linguist,
  qtdemo

* Mon May 15 2006 Laurent Rineau <laurent.rineau__fc_extra@normalesup.org> - 4.1.2-15
- Rename -docs to -doc.
- Files in the -doc subpackage are no longer in %%doc.
- Move qtdemo to the subpackage -doc.
- Fix symlinks in %%{_bindir}.
- Only modify mkspecs/linux-g++*/qmake.conf, instead of all mkspecs/*/qmake.conf.

* Sun May 14 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.2-14
- remove MapNotify from .desktop file(s).
- install -m644 LICENSE.*
- -docs: don't mark examples as %doc
- drop unused %%debug macro

* Sat May 13 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.2-13
- include unpackaged pkgconfig files

* Sat May 13 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.2-12
- fix typos so it actually builds.

* Sat May 13 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.2-11
- drop optional ld.so.conf.d usage, make mandatory
- make %%_bindir symlinks to all %%qtdir/bin stuff (even qt3to4)
- pkgconfig files: hardlinks -> relative symlinks, strip -L%{_libdir}/mysql
  and -L%%{_builddir}/qt-x11-opensource-src-%%version/lib
- cleanup/simplify Summary/%%description entries
- $RPM_BUILD_ROOT -> %%buildroot, $RPM_BUILD_DIR -> %%_builddir

* Sat May 13 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.2-10
- cleanup/simplify license bits, include LICENSE.QPL
- drop unused -styles/-Xt subpkg reference
- drop unused motif extention bits
- drop initialpreference from .deskstop files

* Fri May 12 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.2-9
- drop reference to non-existent config.test/unix/checkavail

* Fri May 12 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.2-8
- simplify build* macros
- lower-case all subpkgs (ie, -MySQL -> -mysql )
- drop BR: perl, sed

* Thu May 11 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.2-7
- rework %%post/%%postun, mostly to placate rpmlint
- drop Prefix:
- drop use of qt4.(sh|csh), they're empty atm anyway
- use Source'd designer.desktop (instead of inline cat/echo)
- symlinks to %%_bindir: qmake4, designer4, qtconfig4
- drop qtrc, qt4 doesn't use it.
- -docs subpkg for API html docs, demos, examples.
- BR: libXcursor-devel libXi-devel (fc5+)

* Thu Apr 27 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.2-6
- devel: Requires: pkgconfig

* Sat Apr 15 2006 Simon Perreault <nomis80@nomis80.org> 4.1.2-5
- Disable C++ exceptions.

* Mon Apr 10 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.2-4
- qt4.(sh|csh): place-holders only, don't define QTDIR (and QTLIB)
  as that (potentially) conflicts with qt-3.x.

* Thu Apr 06 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.2-2
- -devel: Drop (artificial) Conflicts: qt-devel
- fix %%ld_so_conf_d usage
- %%qtdir/%%_lib symlink

* Wed Apr 05 2006 Rex Dieter <rexdieter[AT]users.sf.net> 4.1.2-1
- drop Epoch
- cleanup (a lot!)

* Tue Dec 20 2005 Than Ngo <than@redhat.com> 1:4.1.0-0.1
- update to 4.1.0

* Fri Sep 09 2005 Than Ngo <than@redhat.com> 1:4.0.1-0.1
- update to 4.0.1

